#############################################
### Functions for testing significance of ###
### per-gene categorized mutation rates   ###
#############################################

# Fetch command line arguments
args = commandArgs();
input_file = as.character(args[4]);
output_file = as.character(args[5]);
run_type = as.character(args[6]);
processors = as.numeric(args[7]);
skip_low_mr_genes = as.numeric(args[8]);

# See if we have the necessary packages installed to run in parallel
is.installed <- function( mypkg ) is.element( mypkg, installed.packages()[,1] );
parallel = FALSE;
if( processors > 1 & is.installed( 'doMC' ) & is.installed( 'foreach' )) {
    parallel = TRUE;
}

gethist <- function( xmax, n, p, ptype = "positive_log" ) {
    dbinom( 0:xmax, n, p ) -> ps;
    ps = ps[ps > 0];
    lastp = 1 - sum( ps );
    if( lastp > 0 ) ps = c( ps, lastp );
    if( ptype == "positive_log" ) ps = -log( ps );
    return( ps );
}

binit <- function( x, hmax, bin, dropbin = T ) {
    bs = as.integer( x / bin );
    bs[bs > hmax/bin] = hmax / bin;
    bs[is.na( bs )] = hmax / bin;
    tapply( exp(-x), as.factor( bs ), sum ) -> bs;
    bs = bs[bs>0];
    bs = -log( bs );
    if( dropbin ) bs = as.numeric( bs );
    return( bs );
}

convolute_b <- function( a, b ) {
    tt = NULL;
    for( j in b ) { tt = c( tt, ( a + j )); }
    return( tt );
}

mut_class_test <- function( x, xmax = 100, hmax = 25, bin = 0.001 ) {
    x = as.data.frame( x );
    colnames( x ) = c( "Class", "n", "x", "e" );
    x$p = NA; x$lh0 = NA; x$lh1 = NA;
    tot_muts = x[( x$Class == "Overall" ),]$x;
    tot_bps = x[( x$Class == "Overall" ),]$n;
    overall_bmr = x[( x$Class == "Overall" ),]$e;

    # Remove the row containing overall MR and BMR because we don't want it to be a tested category
    x = x[( x$Class != "Overall" ),];

    # If user wants to skip testing genes with low MRs, measure the relevant MRs of this gene
    gene_mr = 0; indel_mr = 0; indel_bmr = 0; trunc_mr = 0; trunc_bmr = 0;
    if( skip_low_mr_genes == 1 ) {
        if( tot_bps > 0 ) { gene_mr = tot_muts / tot_bps; }
        if( x[( x$Class == "Indels" ),]$n > 0 ) { indel_mr = x[( x$Class == "Indels" ),]$x / x[( x$Class == "Indels" ),]$n; }
        indel_bmr = x[( x$Class == "Indels" ),]$e;
        if( nrow( x[( x$Class == "Truncations" ),] ) > 0 ) {
            if( x[( x$Class == "Truncations" ),]$n > 0 ) { trunc_mr = x[( x$Class == "Truncations" ),]$x / x[( x$Class == "Truncations" ),]$n; }
            trunc_bmr = x[( x$Class == "Truncations" ),]$e;
        }
    }

    # Set pvals of 1 for genes with zero mutations, zero covered bps, or zero overall BMR
    if( tot_muts <= 0 | tot_bps <= 0 | overall_bmr <= 0 ) {
        p.fisher = 1; p.lr = 1; p.convol = 1; qc = 1;
    }
    # If user wants to skip testing genes with low MRs, give them pvals of 1
    else if( skip_low_mr_genes == 1 & gene_mr < overall_bmr & indel_mr <= indel_bmr & trunc_mr <= trunc_bmr ) {
        p.fisher = 1; p.lr = 1; p.convol = 1; qc = 1;
    }
    else {
        # Skip testing mutation categories that have zero BMR, or if this gene has #muts >= #covd bps
        x = x[( x$n > 0 & x$n > x$x & x$e > 0 ),];
        rounded_mut_cnts = round(x$x);
        for( i in 1:nrow(x) ) {
            x$p[i] = binom.test( rounded_mut_cnts[i], x$n[i], x$e[i], alternative = "greater" )$p.value;
            x$lh0[i] = dbinom( rounded_mut_cnts[i], x$n[i], x$e[i], log = T );
            x$lh1[i] = dbinom( rounded_mut_cnts[i], x$n[i], x$x[i] / x$n[i], log = T );
            ni = x$n[i]; ei = x$e[i];
            gethist( xmax, ni, ei, ptype = "positive_log" ) -> bi;
            binit( bi, hmax, bin ) -> bi;
            if( i == 1 ) { hist0 = bi; }
            if( i > 1 & i < nrow(x) ) { hist0 = convolute_b( hist0, bi ); binit( hist0, hmax, bin ) -> hist0; }
            if( i == nrow(x)) { hist0 = convolute_b( hist0, bi ); }
        }

        # Fisher combined p-value
        q = ( -2 ) * sum( log( x$p ));
        df = 2 * length( x$p );
        p.fisher = 1 - pchisq( q, df );

        # Likelihood ratio test
        q = 2 * ( sum( x$lh1 ) - sum( x$lh0 ));
        df = sum( x$lh1 != 0 );
        if( df > 0 ) p.lr = 1 - pchisq( q, df );
        if( df == 0 ) p.lr = 1;

        # Convolution test
        bx = -sum( x[,"lh0"] );
        p.convol = sum( exp( -hist0[hist0>=bx] ));
        qc = sum( exp( -hist0 ));
    }

    # Return results
    rst = list( x = cbind( x, tot_muts, p.fisher, p.lr, p.convol, qc ));
    return( rst );
}

dotest <- function( idx, mut, zgenes ) {
    step = round( length( zgenes ) / processors );
    start = step * ( idx - 1 ) + 1;
    stop = step * idx;
    if( idx == processors ) { stop = length( zgenes ); }
    tt = NULL;
    for( Gene in zgenes[start:stop] ) {
        mutgi = mut[mut$Gene==Gene,];
        mut_class_test( mutgi[,2:5], hmax = 25, bin = 0.001 ) -> z;
        tt = rbind( tt, cbind( Gene, unique( z$x[,(9:11)] )));
    }
    return( tt );
}

combineresults <- function( a, b ) {
    return( rbind( a, b ));
}

smg_test <- function( gene_mr_file, pval_file ) {
    read.delim( gene_mr_file ) -> mut;
    colnames( mut ) = c( "Gene", "Class", "Bases", "Mutations", "BMR" );
    mut$BMR = as.numeric( as.character( mut$BMR ));
    tt = NULL;

    # Run in parallel if we have the needed packages, or fall back to the old way
    if( parallel ) {
        library( 'doMC' );
        library( 'foreach' );
        registerDoMC();
        cat( "Parallel backend installed - splitting across", processors, "cores\n" );

        options( cores = processors );
        mcoptions <- list( preschedule = TRUE );
        zgenes = unique( as.character( mut$Gene ));
        tt = foreach( idx = 1:processors, .combine="combineresults", .options.multicore = mcoptions ) %dopar% {
            dotest( idx, mut, zgenes );
        }
        write.table( tt, file = pval_file, quote = FALSE, row.names = F, sep = "\t" );
    }
    else {
        for( Gene in unique( as.character( mut$Gene ))) {
            mutgi = mut[mut$Gene==Gene,];
            mut_class_test( mutgi[,2:5], hmax = 25, bin = 0.001 ) -> z;
            tt = rbind( tt, cbind( Gene, unique( z$x[,(9:11)] )));
        }
        write.table( tt, file = pval_file, quote = FALSE, row.names = F, sep = "\t" );
    }
}

smg_fdr <- function( pval_file, fdr_file ) {
    read.table( pval_file, header = T, sep = "\t" ) -> x;

    #Calculate FDR measure and write FDR output
    p.adjust( x[,2], method="BH" ) -> fdr.fisher;
    p.adjust( x[,3], method="BH" ) -> fdr.lr;
    p.adjust( x[,4], method="BH" ) -> fdr.convol;
    x = cbind( x, fdr.fisher, fdr.lr, fdr.convol );
    #Rank SMGs starting with lowest convolution test FDR, and then by Likelihood Ratio FDR
    x = x[order( fdr.convol, fdr.lr ),];
    write.table( x, file = fdr_file, quote = FALSE, row.names = F, sep = "\t" );
}

# Figure out which function needs to be invoked and call it
if( run_type == "smg_test" ) { smg_test( input_file, output_file ); }
if( run_type == "calc_fdr" ) { smg_fdr( input_file, output_file ); }

# Fetch command line arguments
args = commandArgs();
input_matrix = as.character(args[4]);
genes_to_plot = as.character(args[5]);
output_pdf = as.character(args[6]);
preserveGeneOrder = as.numeric(as.character(args[7]));

sort.data.frame <- function( x, by ) {
    if(by[[1]] != "~")
        stop("Argument 'by' must be a one-sided formula.")

    ## Make the formula into character and remove spaces
    formc <- as.character(by[2])
    formc <- gsub(" ", "", formc)
    ## If the first character is not + or -, add +
    if(!is.element(substring(formc, 1, 1), c("+", "-")))
        formc <- paste("+", formc, sep = "")

    ## Extract the variables from the formula
    vars <- unlist(strsplit(formc, "[\\+\\-]"))
    vars <- vars[vars != ""] # Remove any extra "" terms

    ## Build a list of arguments to pass to "order" function
    calllist <- list()
    pos <- 1 # Position of + or -
    for(i in 1:length(vars)){
        varsign <- substring(formc, pos, pos)
        pos <- pos + 1 + nchar(vars[i])
        if(is.factor(x[, vars[i]])){
        if(varsign == "-") {
            calllist[[i]] <- -rank(x[, vars[i]])
        } else {
            calllist[[i]] <- rank(x[, vars[i]])
        }
        } else {
        if(varsign == "-") {
            calllist[[i]] <- -x[, vars[i]]
        } else {
            calllist[[i]] <- x[,vars[i]]
        }
        }
    }
    return( x[do.call( "order", calllist ), ] )
}

plotMutRel <- function( infile, genes, outfile, preserveGeneOrder=FALSE) {

    ##------------------
    a = read.table(infile,row.names=1,header=T)
    gene_list = unlist(strsplit(genes, split=","))
    print(genes)
    df=a[,gene_list]

    numSamp=length(df[,1])
    numGenes=length(df)

    if(numGenes < 1){
        return("Error: genes to plot not found in matrix")
    }

    ##adjustments to plot and text sizes for different numbers of samples
    samptext=0.3
    genetext=0.75
    pdfwidth=numSamp/10
    offset=2

    if(numSamp < 50){
        samptext=0.3
        #genetext=0.85
        pdfwidth=numSamp/5
        offset=1.25
    }
    if(numSamp < 35){
        samptext=0.4
    }
    if(pdfwidth < 3) { pdfwidth = 3 }
#    if(numSamp >=100) { genetext=1.1 }
#    if(numSamp >=200) { genetext=1.1 }

    pdfheight=3+(0.25*numGenes-1)
    ##-------

    

    #sort the data using the number of mutations in each, desc
    sortdf = data.frame(g=gene_list[1],s=sum(df[,gene_list[1]]))
    for(i in 2:length(gene_list)){
        sortdf = rbind(sortdf, data.frame(g=gene_list[i],s=sum(df[,gene_list[i]])))
    }
    if(!(preserveGeneOrder)){
      gene_list = as.vector(sort.data.frame(sortdf,~-s)$g)
    }

    print(preserveGeneOrder)
    print(gene_list)

    for(i in rev(gene_list)){
        df = sort.data.frame(df,c("~",paste("-",i,sep="")))
    }

    #output pdf here
    pdf(outfile,height=pdfheight,width=pdfwidth)
    par(xpd=T)
    plot(-100,-100, xlim=c(0,numSamp), ylim=c(-numGenes,0), axes=F, xlab="", ylab="")

    hspace=0.10
    vspace=0.05

    ##plot grey rects
    for(i in -(1:numGenes)){
        rect( (1:numSamp)+hspace,
            rep(i,numSamp)+(1-vspace),
            (1:numSamp)+(1-hspace),
            rep(i,numSamp)+vspace,
            col="grey80",
            border=F );
    }

    ##plot color rects
    for(i in -(1:numGenes)){
        pos=which(df[,gene_list[-i]]==1)
        rect(pos+hspace,
            rep(i,length(pos))+(1-vspace),
            pos+(1-hspace),
            rep(i,length(pos))+vspace,
            col="darkgreen",
            border=F )
    }

    ##gene labels
    for(i in -(1:numGenes)){
        text(1,i+0.5,gene_list[-i],pos=2, cex=genetext)
    }

    ##sample labels
    for(i in 1:numSamp){
        text(i+offset,-numGenes,row.names(df)[i],srt=90,pos=2,cex=samptext)
    }

    dev.off()
}

plotMutRel( input_matrix, genes_to_plot, output_pdf, preserveGeneOrder );

#determine which test method to use
method = as.character(commandArgs()[4]);

if (method == "glm") {

    ### This program is for Generalized Linear Model (GLM) analysis
    ### Y = X + covar1 + covar2 ......
    ### Usually (not limited),
    ### Y is clinical trait (quantitative or binary)
    ### X is variant/gene/mutation etc.
    ### covar means covariate
    ### by Qunyuan Zhang (qunyuan@wustl.edu), 02/16/2012 updated 

    ### input options
    model.file = as.character(commandArgs()[5]);
    y.file = as.character(commandArgs()[6]);
    x.file = as.character(commandArgs()[7]);
    out.file = as.character(commandArgs()[8]);
    x.names="*";

    ### to run it on command line, type
    # R --no-save < glm.R model.file y.file x.file * out.csv
    # or (if you want to define x variables)
    # R --no-save < glm.R model.csv y.file x.file x1|x2|x3 out.csv
    # or (if x.file has been merged into y.file)
    # R --no-save < glm.R model.csv y.file * x1|x2|x3 out.csv
    # or (if you have defined x variable in model.file)
    # R --no-save < glm.R model.csv y.file * * out.csv

    ### about model.file 
    # column "type":  Q=quantitative trait, B=binary trait
    # column "y":     trait name
    # colum  "x":     variant/gene name; if x=NA or blank, it will determined by x.file and x.names
    # column "cvar":  covariate(s)
    # tab delimited 

    ### about y.file 
    # trait data file, column 1 must be sample id 
    # tab delimited 

    ### about x.file
    # usually mutation/variant/geene data file 
    # the first column must be sample id (the same as in y.file, ordered or not)
    # tab delimited  
    # x.file="*" if x.file already merged into y.file 

    ### about x.names
    # x.names="*" will use all column names in x.file as x variable names
    # or you can define it in the format x.names="gene1|gene2|gene3"
    # self-defined x.names have to be found in column names of y.file and/or x.file  

    #################### myglm fuction ##############
    myglm=function(z,trait,variant,covar=NA,ytype) {
        if (nchar(covar)==0 | is.na(covar) | is.null(covar)) { 
            model=formula(paste(trait,"~",variant)) 
        } else {
            model=formula(paste(trait,"~",variant,"+",covar))
        }
        if (ytype=="B") fit=glm(formula=model,data=z,family=binomial(link = "logit"))
        if (ytype=="Q") fit=glm(formula=model,data=z,family=gaussian(link = "identity"))
        fit
    }
    #################################################


    ### data input #####
    read.table(model.file,colClasses="character",na.strings = c("","NA"),sep="\t",header=T)->md
    read.table(y.file,na.strings = c("","NA"),sep="\t",header=T)->y
    if (x.names!="*") x.names=strsplit(x.names,split="[|]")[[1]]

    if (x.file!="*")
    {
        read.table(x.file,na.strings = c("","NA"),sep="\t",header=T)->x
        xid=colnames(x)[1]
        xs=colnames(x)[-1]
        if (x.names!="*") {x=x[,c(xid,x.names)];xs=colnames(x)[-1]}
        x.names=xs
        yid=colnames(y)[1]
        ysid = ! (colnames(y) %in% xs)
        y=y[,ysid]
        if (sum(ysid)==1) {y=data.frame(id=y);colnames(y)[1]=yid}
        #y=merge(y,x,by.x = xid, by.y = yid)
        y=merge(x,y,by.x = xid, by.y = yid)
    }

    ######### analysis ##########
    tt=NULL
    for (i in c(1:nrow(md)))
    {
        ytype=md[i,1];yi=md[i,2];xs=md[i,3];covi=md[i,4];memo=md[i,5]
        if (!is.na(xs) & nchar(xs)>0) xs=strsplit(xs,split="[|]")[[1]]
        if (is.na(xs)[1]|nchar(xs)[1]==0) xs=x.names 
        if (length(covi)==0) covi=NA
        for (xi in xs)
        {
            print(yi); print(xi); print(covi); print("******")
            if (ytype=="Q") try(anova(myglm(y,yi,xi,covi,ytype),test="F"))->fit
            if (ytype=="B") try(anova(myglm(y,yi,xi,covi,ytype),test="Chisq"))->fit
            if (class(fit)[1]!="try-error")
            {
                fit=as.matrix(fit)
                if (xi %in% rownames(fit)) tt=rbind(tt, cbind(yi,ytype,xi,as.data.frame(t(fit[xi,])),covi,memo))
            }
        }
    }
    #"yi","ytype","xi","Df","Deviance","Resid. Df","Resid. Dev","F","Pr(>F)","covi","memo"
    if (ytype=="Q") colnames(tt) = c("y","y_type","x","degrees_freedom","deviance","residual_degrees_freedom","residual_deviance","F_statistic","p-value","covariants","memo");
    if (ytype=="B") colnames(tt) = c("y","y_type","x","degrees_freedom","deviance","residual_degrees_freedom","residual_deviance","p-value","covariants","memo");
    write.table(tt,file=out.file,quote=F,sep="\t",row.names=F);

} else {

    # else, we process numerical or categorical clinical data correlation

    clinical_data = as.character(commandArgs()[5]);
    mutation_matrix = as.character(commandArgs()[6]);
    output_file = as.character(commandArgs()[7]);

    # FUNCTION finds the correlation between two variables
    cor2=function(ty,tx,method)
    {

        id=intersect(!is.na(ty),!is.na(tx));
        ty=ty[id];
        tx=tx[id];

        if(method=="cor")
        {
            tst=cor.test(tx,ty);
            s=tst$est;
            p=tst$p.value;
        }

        if(method=="wilcox")  #x must be (0,1) mutation data
        {
            tst=wilcox.test(x=ty[tx==0],y=ty[tx>=1])
            s=tst$stat
            p=tst$p.value
        }

        if(method=="chisq")
        {
            tst=chisq.test(tx,ty);
            s=tst$stat;
            p=tst$p.value;
        }

        if(method=="fisher")
        {
            tst=fisher.test(tx,ty)
            s=tst$p.value
            p=tst$p.value
        }

        if(method=="anova")
        {
            tst=summary(aov(ty~tx,as.data.frame(cbind(tx,ty))))
            s=tst[[1]]$F[1]
            p=tst[[1]]$Pr[1]
        }

        tt=c(p,s);
        tt;
    }
    # END cor2

    # FUNCTION runs correlation test on matrixes of data
    cor2test =function(y,x=NULL,method="cor",cutoff=1,sep="\t",outf=NULL)
    {

        if (!is.null(x))
        {

            if (length(x)==1) {read.table(x,header=T,sep=sep)->x;}
            if (length(y)==1) {read.table(y,header=T,sep=sep)->y;}
            colnames(y)[1]="id";
            colnames(x)[1]="id";
            tt=character(0);
            for (vi in colnames(x)[-1])
            {
                for (vj in colnames(y)[-1])
                {
                    tx=x[,c("id",vi)];
                    tx=tx[!is.na(tx[,vi]),];
                    tx=tx[!duplicated(tx[,"id"]),];
                    ty=y[,c("id",vj)];
                    ty=ty[!is.na(ty[,vj]),];
                    ty=ty[!duplicated(ty[,"id"]),];
                    xy=merge(tx,ty,by.x="id",by.y="id");
                    tx=xy[,2];
                    ty=xy[,3];
                    n=length(xy[,"id"]);
                    rst=try(cor2(ty,tx,method));
                    if (class(rst)=="try-error") {p=NA;s=NA;} else {p=rst[1];s=rst[2];}
                    t=c(vi,vj,method,n,s,p)

                    tt=rbind(tt,t);
                } #end vj
            } #end vi

            rownames(tt)=NULL;
            colnames(tt)=c("x","y","method","n","s","p");
            tt=as.data.frame(tt);
            tt[,"s"]=as.character(tt[,"s"]);
            tt[,"s"]=as.numeric(tt[,"s"]);
            tt[,"p"]=as.character(tt[,"p"]);
            tt[,"p"]=as.numeric(tt[,"p"]);
            fdr=p.adjust(tt[,"p"],method="fdr");
            bon=p.adjust(tt[,"p"],method="bon");
            tt=cbind(tt,fdr,bon);
            tt=tt[order(tt[,"p"]),];
        }

        if (is.null(x))
        {

            if (length(y)==1) {read.table(y,header=T,sep=sep)->y;}
            x=y;
            nxy=ncol(y)-1;
            colnames(y)[1]="id";
            colnames(x)[1]="id"
            tt=character(0);
            for (i in c(1:(nxy-1)))
            {
                for (j in c((i+1):nxy))
                {

                    vi=colnames(x)[-1][i];
                    vj=colnames(y)[-1][j];

                    tx=x[,c("id",vi)];
                    tx=tx[!is.na(tx[,vi]),];
                    tx=tx[!duplicated(tx[,"id"]),]
                    ty=y[,c("id",vj)];
                    ty=ty[!is.na(ty[,vj]),];
                    ty=ty[!duplicated(ty[,"id"]),];
                    xy=merge(tx,ty,by.x="id",by.y="id");
                    tx=xy[,2];
                    ty=xy[,3];
                    n=length(xy[,"id"]);
                    rst=try(cor2(ty,tx,method));
                    if (class(rst)=="try-error") {p=NA;s=NA;} else {p=rst[1];s=rst[2];}
                    t=c(vi,vj,method,n,s,p);
                    tt=rbind(tt,t);
                } #end vj
            } #end vi

            rownames(tt)=NULL;
            colnames(tt)=c("x","y","method","n","s","p");
            tt=as.data.frame(tt);
            tt[,"s"]=as.character(tt[,"s"]);
            tt[,"s"]=as.numeric(tt[,"s"]);
            tt[,"p"]=as.character(tt[,"p"]);
            tt[,"p"]=as.numeric(tt[,"p"]);
            fdr=p.adjust(tt[,"p"],method="fdr");
            bon=p.adjust(tt[,"p"],method="bon");
            tt=cbind(tt,fdr,bon);
            tt=tt[order(tt[,"p"]),];
        }


        if (!is.null(outf))
        {
            colnames(tt)=c("x","y","method","n","s","p","fdr","bon");

            #The amount of precision that R prints with is somehow machine dependent (or the R version?)
            tt[,"s"] = sapply(tt[,"s"], sprintf, fmt="%.4E");
            tt[,"p"] = sapply(tt[,"p"], sprintf, fmt="%.4E");
            tt[,"fdr"] = sapply(tt[,"fdr"], sprintf, fmt="%.2E");
            tt[,"bon"] = sapply(tt[,"bon"], sprintf, fmt="%.2E");

            #The ordering should be done after reformatting the precision (duh)
            tt=tt[order(tt[,"x"]),];
            tt=tt[order(tt[,"p"]),];

            write.table(tt,file=outf,quote=FALSE,row.names=FALSE,sep=",");
        }
        invisible(tt);
    }
    #END cor2test

    #run correlation test using function
    cor2test(y = clinical_data, x = mutation_matrix, method = method, outf = output_file);
}

#get command line arguments
mutation_file = as.character(commandArgs()[4]);
permutations = as.numeric(commandArgs()[5]);
output_file = as.character(commandArgs()[6]);

# FUNCTION prepare mutation matrix data for permutation
seq.vjoint=function(x)
{
    tt=NULL;
    for (i in 1:length(x)) 
    {
        tt=c(tt,rep(names(x[i]),x[i]));
    }
    tt;
}
# END seq.vjoint

# FUNCTION randomly permute the mutation matrix, keeping mutation-number/sample unchanged
matrix.sample.v1=function(x,keep.freq=T)
{
    colSums(x)->pool;
    rowSums(x)->freq;
    freq=freq[order(freq,decreasing=T)];
    tt=NULL;
    for (i in c(1:length(freq)))
    {
        pooli=seq.vjoint(pool);
        xi=NULL;
        for (j in 1:freq[i])
        {
            if (length(pooli)>1) sample(pooli,1)->temp;
            if (length(pooli)==1) pooli->temp;
            xi=c(xi,temp);
            pooli=pooli[pooli!=temp];
        }
        tt=rbind(tt,cbind(i,xi));
        pool[xi]=pool[xi]-1;
        pool=pool[pool>0];
    }
    tt=table(tt[,1],tt[,2]);
    tt[tt>1]=1;
    tt;
}
# END matrix.sample.v1

# FUNCTION calculate the probability of having no correlation between any two genes
prob.concur=function(x)
{
    x>0->x;
    cols=colnames(x);
    cols=cols[order(cols)]; 
    n=length(cols);

    tt=NULL;
    for (i in 1:(n-1))
    {
        for (j in (i+1):n)
        {
            vi=cols[i];
            vj=cols[j];
            sum(x[,vi] & x[,vj])->nand;
            sum(x[,vi] != x[,vj])->nexc;
            ni=sum(x[,vi]);
            nj=sum(x[,vj]);
            temp=cbind(vi,vj,ni,nj,nand,nexc);
            tt=rbind(tt,temp);
        }
    }
    tt=as.data.frame(tt,stringsAsFactors=F);
    tt$nand=as.numeric(tt[,"nand"]);
    tt$nexc=as.numeric(tt[,"nexc"]);
    tt;
}
# END prob.concur

# FUNCTION performing mutation correlation
mut_cor_permu_test=function(x=NULL,n.permu=100,seed=NULL,mut.file=NULL,out.file=NULL,out.rdata=NULL)
{

    if (!is.null(mut.file)) read.table(mut.file,header=T)->x

    x=x[,-1];x[x>0]=1
    x=x[rowSums(x)>0,colSums(x)>0]
    prob.concur(x)->pc0

    if (!is.null(seed)) set.seed(seed)

    pp=0;en=0
    for (i in 1:n.permu)
    {

        doit=1; 
        while(doit==1) 
        {
            xi=matrix.sample.v1(x);
            if (max(xi)==1) doit=0;
        }

        prob.concur(xi)->pci;
        en=en+pci[,c("nand","nexc")];
        as.numeric(pci$nand>=pc0$nand)->pand;
        as.numeric(pci$nexc>=pc0$nexc)->pexc;
        pp=pp+cbind(pand,pexc);
    }

    en=en/n.permu;pp=pp/n.permu;
    pci[,c("nand","nexc")]=en;
    pci=cbind(pci,pp);
    tt=merge(pc0,pci,by.x=c("vi","vj"),by.y=c("vi","vj"));

    if (!is.null(out.rdata)) save(tt,file=out.rdata,compress=T);
    names(tt)= c("Gene1","Gene2","CntGene1","CntGene2","AndCnt","XorCnt","Perm_CntGene1","Perm_CntGene2","Perm_AndCnt","Perm_XorCnt","Pvalue_And","Pvalue_Xor")
    if (!is.null(out.file)) write.table(tt,file=out.file,quote=F,sep="\t",row.names=F);

    invisible (tt);
}
#END mut_cor_permu_test

#run test using mut_cor_permu_test
mut_cor_permu_test(mut.file=mutation_file,n.permu=permutations,out.file=output_file);

### Survival analysis for mutation data ###

### original location of code: /gscuser/qzhang/gstat/survival/survival.R
### example input file: /gscuser/qzhang/gstat/survival/tcga.tsv

### Run it on command line like below 
### for example,   R --no-save --args < survival.R vital_status.input mut_matrix.input legend.placement output_dir & 

### clinical data /vital status input file, first three columns are sample_ID, survival_time, vital_status (0=living, 1=deceased)

######################## read input arguments

clinical.survival.data=commandArgs()[4];
mut.data=commandArgs()[5];
legend.placement=commandArgs()[6];
out.dir=commandArgs()[7];

######################## read and prepare data 

vitals = read.table(clinical.survival.data,header=T);
mut_matrix = read.table(mut.data,header=T);
x = merge(vitals,mut_matrix,by.x=1,by.y=1);
write.table(x,file=paste(out.dir,"survival_analysis_data_matrix.csv",sep="/"),quote=F,append=F,row.names=F,sep="\t")
colnames(x)[-c(1:3)]->phenos
if (class(x[,phenos])=="integer" & length(unique(x[,phenos]))<6) x[,phenos] [x[,phenos]>1]=1



######################### survival analysis

library(survival)
logr=NULL

for (phenotype in phenos) 
{
    #clean data
    loopdata <- x;
    loopdata <- loopdata[!is.na(loopdata[,phenotype]),];
    loopdata <- loopdata[!is.na(loopdata[,3]),];
    loopdata <- loopdata[!is.na(loopdata[,2]),];
    status=loopdata[,3];
    time=loopdata[,2];
    x1=loopdata[,phenotype];
    base.class = as.vector(sort(unique(x1)))[1];

    coxph(Surv(time, status) ~ x1, loopdata) -> co;
    summary(co)->co; co$conf->cox; co$logtest[3]->p; co$coef[5]->indv.p;
    rownames(cox) = sub("x1","",rownames(cox));
    if (length(rownames(cox))==1 && rownames(cox)[1]=="") { rownames(cox)[1] = "1"; }
    logr=rbind(logr,cbind(base.class,rownames(cox),phenotype,cox,indv.p,p))

    mfit.by <- survfit(Surv(time, status == 1) ~ x1, data = loopdata)
    ## file name for plot
    bitmap(file=paste(out.dir,"/",phenotype,"_survival_plot.png",sep=""))
    ## create survival plot
    plot(mfit.by,lty=1:10,ylab="Survival Probability",xlab="Time",col=c(1:10))
    if (dim(table(x1))>1) {
        title(paste(phenotype,", P=",signif(p,3),sep=""));
    } else {
        title(paste(phenotype));
    }
    legend(x=legend.placement, legend=names(table(x1)), lty = 1:10, col=c(1:10)) 
    dev.off()

}

########################## calculate fdr

logr=logr[,-5]; 
if (length(phenos) < 2) { logr=(t(logr)); }
fdr=p.adjust(as.numeric(logr[,"p"]),"fdr")
logr=cbind(logr,fdr)

######################### print output

colnames(logr)[1:9]=c("base.class","comparison.class","phenotype","hazard.ratio","lower.95","upper.95","2-class-p-value","p-value","fdr")
logr=logr[order(logr[,"p-value"]),]
write.table(logr,file=paste(out.dir,"survival_analysis_test_results.csv",sep="/"),quote=F,append=F,row.names=F,sep="\t")
